// Generated by purs version 0.13.2
"use strict";
var $foreign = require("./foreign.js");
var Control_Alt = require("../Control.Alt/index.js");
var Control_Applicative = require("../Control.Applicative/index.js");
var Control_Apply = require("../Control.Apply/index.js");
var Control_MonadZero = require("../Control.MonadZero/index.js");
var Data_Array = require("../Data.Array/index.js");
var Data_Eq = require("../Data.Eq/index.js");
var Data_Functor = require("../Data.Functor/index.js");
var Data_HeytingAlgebra = require("../Data.HeytingAlgebra/index.js");
var Data_Maybe = require("../Data.Maybe/index.js");
var Data_Semigroup = require("../Data.Semigroup/index.js");
var Data_String_Common = require("../Data.String.Common/index.js");
var Effect = require("../Effect/index.js");
var Effect_Exception = require("../Effect.Exception/index.js");
var Node_FS_Sync = require("../Node.FS.Sync/index.js");
var Node_Path = require("../Node.Path/index.js");
var Node_Platform = require("../Node.Platform/index.js");
var Node_Process = require("../Node.Process/index.js");
var Options_Applicative_Builder = require("../Options.Applicative.Builder/index.js");
var Options_Applicative_Builder_Internal = require("../Options.Applicative.Builder.Internal/index.js");
var Options_Applicative_Extra = require("../Options.Applicative.Extra/index.js");
var Options_Applicative_Internal_Utils = require("../Options.Applicative.Internal.Utils/index.js");
var Options_Applicative_Types = require("../Options.Applicative.Types/index.js");
var ScriptCommand = (function () {
    function ScriptCommand(value0) {
        this.value0 = value0;
    };
    ScriptCommand.create = function (value0) {
        return new ScriptCommand(value0);
    };
    return ScriptCommand;
})();
var BuildCommand = (function () {
    function BuildCommand(value0, value1) {
        this.value0 = value0;
        this.value1 = value1;
    };
    BuildCommand.create = function (value0) {
        return function (value1) {
            return new BuildCommand(value0, value1);
        };
    };
    return BuildCommand;
})();
var spagoCmd = (function () {
    var $17 = Data_Eq.eq(Data_Maybe.eqMaybe(Node_Platform.eqPlatform))(Node_Process.platform)(new Data_Maybe.Just(Node_Platform.Win32.value));
    if ($17) {
        return "spago.cmd";
    };
    return "spago";
})();
var setCommandIncludes = function (includesArr) {
    return function (cmd) {
        if (cmd instanceof BuildCommand) {
            return new BuildCommand(cmd.value0, includesArr);
        };
        if (cmd instanceof ScriptCommand) {
            return new ScriptCommand(cmd.value0);
        };
        throw new Error("Failed pattern match at Pscid.Options (line 91, column 38 - line 93, column 40): " + [ cmd.constructor.name ]);
    };
};
var scanDefaultDirectories = (function () {
    var mkGlob = function (dir) {
        return dir + "/**/*.purs";
    };
    var defaultDirectories = [ "src", "app", "test", "tests" ];
    return Data_Array.filterA(Effect.applicativeEffect)((function () {
        var $48 = Data_Functor.map(Effect.functorEffect)((function () {
            var $50 = Data_HeytingAlgebra.not(Data_HeytingAlgebra.heytingAlgebraBoolean);
            return function ($51) {
                return $50(Data_Array["null"]($51));
            };
        })());
        return function ($49) {
            return $48($foreign.glob(mkGlob($49)));
        };
    })())(defaultDirectories);
})();
var pulpCmd = (function () {
    var $22 = Data_Eq.eq(Data_Maybe.eqMaybe(Node_Platform.eqPlatform))(Node_Process.platform)(new Data_Maybe.Just(Node_Platform.Win32.value));
    if ($22) {
        return "pulp.cmd";
    };
    return "pulp";
})();
var printCLICommand = function (v) {
    if (v instanceof ScriptCommand) {
        return v.value0;
    };
    if (v instanceof BuildCommand && v.value1.length === 0) {
        return v.value0;
    };
    if (v instanceof BuildCommand) {
        return v.value0 + (" -I " + Data_String_Common.joinWith(":")(v.value1));
    };
    throw new Error("Failed pattern match at Pscid.Options (line 76, column 19 - line 82, column 50): " + [ v.constructor.name ]);
};
var npmCmd = (function () {
    var $29 = Data_Eq.eq(Data_Maybe.eqMaybe(Node_Platform.eqPlatform))(Node_Process.platform)(new Data_Maybe.Just(Node_Platform.Win32.value));
    if ($29) {
        return "npm.cmd";
    };
    return "npm";
})();
var isSpagoProject = function __do() {
    var v = Node_Process.cwd();
    var fp = Node_Path.concat([ v, "spago.dhall" ]);
    return Effect_Exception.catchException(function (v1) {
        return Control_Applicative.pure(Effect.applicativeEffect)(false);
    })(Node_FS_Sync.exists(fp))();
};
var mkCommand = function (cmd) {
    return function __do() {
        var v = isSpagoProject();
        var v1 = $foreign.hasNamedScript("pscid:" + cmd)();
        var v2 = $foreign.hasNamedScript(cmd)();
        var npmSpecificCommand = Data_Functor.voidLeft(Data_Maybe.functorMaybe)(Control_MonadZero.guard(Data_Maybe.monadZeroMaybe)(v1))(new ScriptCommand(npmCmd + (" run -s pscid:" + cmd)));
        var npmBuildCommand = Data_Functor.voidLeft(Data_Maybe.functorMaybe)(Control_MonadZero.guard(Data_Maybe.monadZeroMaybe)(v2))(new ScriptCommand(npmCmd + (" run -s " + cmd)));
        var buildCommand = (function () {
            if (v) {
                return new BuildCommand(spagoCmd + (" " + cmd), [  ]);
            };
            return new BuildCommand(pulpCmd + (" " + cmd), [  ]);
        })();
        return Data_Maybe.fromMaybe(buildCommand)(Control_Alt.alt(Data_Maybe.altMaybe)(npmSpecificCommand)(npmBuildCommand));
    };
};
var defaultOptions = {
    port: Data_Maybe.Nothing.value,
    buildCommand: new BuildCommand(pulpCmd + " build", [  ]),
    outputDirectory: "output",
    testCommand: new BuildCommand(pulpCmd + " test", [  ]),
    testAfterRebuild: false,
    sourceDirectories: [  ],
    censorCodes: [  ]
};
var mkDefaultOptions = Control_Apply.apply(Effect.applyEffect)(Control_Apply.apply(Effect.applyEffect)(Data_Functor.map(Effect.functorEffect)(function (v) {
    return function (v1) {
        return function (v2) {
            return {
                buildCommand: v,
                testCommand: v1,
                sourceDirectories: v2,
                censorCodes: defaultOptions.censorCodes,
                outputDirectory: defaultOptions.outputDirectory,
                port: defaultOptions.port,
                testAfterRebuild: defaultOptions.testAfterRebuild
            };
        };
    };
})(mkCommand("build")))(mkCommand("test")))(scanDefaultDirectories);
var buildOptions = function (defaults) {
    return function (v) {
        var sepArguments = function (sep) {
            var $52 = Data_Array.filter(Data_HeytingAlgebra.not(Data_HeytingAlgebra.heytingAlgebraFunction(Data_HeytingAlgebra.heytingAlgebraBoolean))(Data_String_Common["null"]));
            var $53 = Data_String_Common.split(sep);
            return function ($54) {
                return $52($53($54));
            };
        };
        var includesArr = sepArguments(";")(v.includes);
        return {
            port: v.port,
            testAfterRebuild: v.testAfterRebuild,
            sourceDirectories: Data_Semigroup.append(Data_Semigroup.semigroupArray)(defaults.sourceDirectories)(includesArr),
            censorCodes: sepArguments(",")(v.censor),
            outputDirectory: v.outputDirectory,
            buildCommand: setCommandIncludes(includesArr)(defaults.buildCommand),
            testCommand: setCommandIncludes(includesArr)(defaults.testCommand)
        };
    };
};
var options = function (defaults) {
    return Control_Apply.apply(Options_Applicative_Types.parserApply)(Control_Apply.apply(Options_Applicative_Types.parserApply)(Control_Apply.apply(Options_Applicative_Types.parserApply)(Control_Apply.apply(Options_Applicative_Types.parserApply)(Data_Functor.map(Options_Applicative_Types.parserFunctor)(function (v) {
        return function (v1) {
            return function (v2) {
                return function (v3) {
                    return function (v4) {
                        return buildOptions(defaults)({
                            port: v,
                            testAfterRebuild: v1,
                            outputDirectory: v4,
                            includes: v2,
                            censor: v3
                        });
                    };
                };
            };
        };
    })(Data_Maybe.optional(Options_Applicative_Types.parserAlternative)(Options_Applicative_Builder.option(Options_Applicative_Builder["int"])(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["long"](Options_Applicative_Builder_Internal.optionFieldsHasName)("port"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["short"](Options_Applicative_Builder_Internal.optionFieldsHasName)("p"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.metavar(Options_Applicative_Builder_Internal.optionFieldsHasMetavar)("PORT"))(Options_Applicative_Builder.help("What port to start the ide server on"))))))))(Options_Applicative_Builder["switch"](Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["long"](Options_Applicative_Builder_Internal.flagFieldsHasName)("test"))(Options_Applicative_Builder.help("Run tests after successful rebuild")))))(Control_Alt.alt(Options_Applicative_Types.parserAlt)(Options_Applicative_Builder.strOption(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["long"](Options_Applicative_Builder_Internal.optionFieldsHasName)("include"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["short"](Options_Applicative_Builder_Internal.optionFieldsHasName)("I"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.help("Directories for additional PureScript source files, separated by `;`"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.value(Options_Applicative_Builder_Internal.optionFieldsHasValue)(""))(Options_Applicative_Builder.metavar(Options_Applicative_Builder_Internal.optionFieldsHasMetavar)("INCLUDES")))))))(Control_Applicative.pure(Options_Applicative_Types.parserApplicative)(""))))(Control_Alt.alt(Options_Applicative_Types.parserAlt)(Options_Applicative_Builder.strOption(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["long"](Options_Applicative_Builder_Internal.optionFieldsHasName)("censor-codes"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.help("Warning codes to ignore, seperated by `,`"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.value(Options_Applicative_Builder_Internal.optionFieldsHasValue)(""))(Options_Applicative_Builder.metavar(Options_Applicative_Builder_Internal.optionFieldsHasMetavar)("CENSOR-CODES"))))))(Control_Applicative.pure(Options_Applicative_Types.parserApplicative)(""))))(Control_Alt.alt(Options_Applicative_Types.parserAlt)(Options_Applicative_Builder.strOption(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["long"](Options_Applicative_Builder_Internal.optionFieldsHasName)("output"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder["short"](Options_Applicative_Builder_Internal.optionFieldsHasName)("O"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.help("Output directory for compiled JavaScript"))(Data_Semigroup.append(Options_Applicative_Builder_Internal.modSemigroup)(Options_Applicative_Builder.value(Options_Applicative_Builder_Internal.optionFieldsHasValue)("output"))(Options_Applicative_Builder.metavar(Options_Applicative_Builder_Internal.optionFieldsHasMetavar)("OUTPUT")))))))(Control_Applicative.pure(Options_Applicative_Types.parserApplicative)("output")));
};
var optionParser = (function () {
    var opts = function (defaults) {
        return Options_Applicative_Builder.info(Options_Applicative_Internal_Utils.apApplyFlipped(Options_Applicative_Types.parserApply)(options(defaults))(Options_Applicative_Extra.helper))(Data_Semigroup.append(Options_Applicative_Builder.infoModSemigroup)(Options_Applicative_Builder.fullDesc)(Data_Semigroup.append(Options_Applicative_Builder.infoModSemigroup)(Options_Applicative_Builder.progDesc("Watches and rebuilds PureScript source files"))(Options_Applicative_Builder.header("pscid - A lightweight, fast and unintrusive PureScript file-watcher"))));
    };
    return function __do() {
        var v = mkDefaultOptions();
        return Options_Applicative_Extra.execParser(opts(v))();
    };
})();
module.exports = {
    defaultOptions: defaultOptions,
    scanDefaultDirectories: scanDefaultDirectories,
    spagoCmd: spagoCmd,
    pulpCmd: pulpCmd,
    npmCmd: npmCmd,
    mkDefaultOptions: mkDefaultOptions,
    ScriptCommand: ScriptCommand,
    BuildCommand: BuildCommand,
    printCLICommand: printCLICommand,
    setCommandIncludes: setCommandIncludes,
    mkCommand: mkCommand,
    isSpagoProject: isSpagoProject,
    buildOptions: buildOptions,
    options: options,
    optionParser: optionParser,
    hasNamedScript: $foreign.hasNamedScript,
    glob: $foreign.glob
};
